
#include <can.h>
#include <p30fxxxx.h>

void	Initial_CAN( void )
{
		CAN1SetOperationMode( 	CAN_IDLE_CON & CAN_MASTERCLOCK_1 & 
								CAN_REQ_OPERMODE_CONFIG ) ;

		while ( C1CTRLbits.OPMODE <= 3 );

			CAN1Initialize( CAN_SYNC_JUMP_WIDTH3 & CAN_BAUD_PRE_SCALE(4),
							CAN_WAKEUP_BY_FILTER_DIS &
							CAN_PHASE_SEG2_TQ(5) &
							CAN_PHASE_SEG1_TQ(8) &
							CAN_PROPAGATIONTIME_SEG_TQ(2) & 
							CAN_SEG2_FREE_PROG & CAN_SAMPLE1TIME ) ;

			CAN1SetFilter ( (char) 0 , CAN_FILTER_SID( 0x100 ) & CAN_RX_EID_DIS ,
							CAN_FILTER_EID( 0x00 )) ;
			CAN1SetFilter ( (char) 1 , CAN_FILTER_SID( 0x100 ) & CAN_RX_EID_DIS ,
							CAN_FILTER_EID( 0x00 )) ;

			CAN1SetMask ( 	(char)0 , CAN_MASK_SID ( 0x7ff ) & CAN_MATCH_FILTER_TYPE , 
							CAN_MASK_EID( 0x00) ) ; 

			CAN1SetTXMode( (char) 0 , CAN_TX_STOP_REQ & CAN_TX_PRIORITY_HIGH ) ;
			CAN1SetRXMode( (char) 0 , CAN_RXFUL_CLEAR & CAN_BUF0_DBLBUFFER_DIS ) ;

			CAN1SetOperationMode( 	CAN_IDLE_CON & CAN_CAPTURE_DIS & CAN_MASTERCLOCK_1 &
									CAN_REQ_OPERMODE_NOR ) ;							
}
