#include <p18f8722.h>
#include <i2c.h>
#include <delays.h>

void		I2C_Initialize(void)
{
		TRISCbits.TRISC3 = 1 ;
		TRISCbits.TRISC4 = 1 ;
		SSP1CON1 = 0b00101000 ;
		
		SSP1ADD = 0x40 ;
}

void 	MCP9800_Write( unsigned char MCP9800_Pointer , unsigned char MCP9800_Data )
{
	
	while ( EEAckPolling(0x9a) != 0 ) ;
	EEByteWrite( 0xA0,MCP9800_Pointer, MCP9800_Data  )	;

}

unsigned char 	MCP9800_ByteRead( unsigned char MCP9800_Pointer )
{
	
	while ( EEAckPolling(0x9a) != 0 ) ;
	return EERandomRead( 0x9a , MCP9800_Pointer ) ;
}
